Bug 52904

Summary: Listen directive is broken when the MPM has per-directory config
Product: Apache httpd-2 Reporter: Steinar H. Gunderson <sgunderson>
Component: CoreAssignee: Apache HTTPD Bugs Mailing List <bugs>
Status: RESOLVED FIXED    
Severity: normal Keywords: FixedInTrunk
Priority: P2    
Version: 2.4.1   
Target Milestone: ---   
Hardware: PC   
OS: Linux   

Description Steinar H. Gunderson 2012-03-14 00:53:04 UTC
Hi,

r806010 introduced a hack where the per-directory config pointer (termed "dummy") is assumed to always be NULL when called from the config parser, and then abused to mark the listening sockets with differing parameters. I could not find any use of this functionality within Apache or outside it, only http://www.gossamer-threads.com/lists/apache/dev/372147 which says "wait and see".

Unfortunately, this breaks if the MPM in use _does_ have a per-directory config; the config file is parsed twice, and since the config pointer will be different (and non-NULL) between the two calls to Listen(), there will be a fatal error. In particular, mpm-itk (mpm-itk.sesse.net) does this, which prevents a clean 2.4 port.

Please revert this patch (and optionally replace it with something cleaner); it is not in use by any current code and breaks a valid configuration, albeit one with external modules.
Comment 1 Stefan Fritsch 2012-03-24 18:12:11 UTC
r1304874
proposed for 2.4
Comment 2 Stefan Fritsch 2012-05-06 07:25:45 UTC
fixed in 2.4.2